function [Y] = extendimage(X, n)
% Rozen obrazu na specifikovanou velikost zrcadlenm okraj
%
%   [Y] = extendimage(X, n)
%
%   Vstupy: 
%   X ... vstupn obraz
%   n ... poet pixel, o kter m bt obraz z kad strany rozen
%   
%   Vstup: 
%   Y ... rozen obraz 
%
%
%   Datum posledn pravy: 17. 3. 2018, KF


Y = zeros(size(X) + 2 * n);
Y(n+1 : end-n, n+1 : end-n) = X;
Y(:, 1 : n) = fliplr(Y(:, n+1 : 2*n));
Y(:, end-n+1 : end) = fliplr(Y(:, end-2*n+1 : end-n));
Y(1 : n, :) = flipud(Y(n+1 : 2*n, :));
Y(end-n+1 : end, :) = flipud(Y(end-2*n+1 : end-n, :));

end

