% Algoritmus 1
%
% Jedn se o lohu statick lokalizace, piem jako men jsou chpny
% vzdlenosti k referennm bodm (beaconm), kter byly zskny pepotem
% z namench sil signlu
%
% Pedpokldaj se datov soubory s umstnm 'data\exp1\exp1_X.csv', 
% kde X = 1, 2, ..., 20 je slo testovacho bodu, 
% a soubor 'data\exp1\beacons.csv' obsahujc souadnice referennch bod

clear

filename = 'data\exp1\exp1_1.csv';

beaconsAll = csvread('data\exp1\beacons.csv');
positionTrue = csvread(filename, 0, 0, [0 0 0 1]);
measurementsAll = csvread(filename, 1, 0);

notNaNIndices = find(~isnan(measurementsAll(1, :)));
beacons = beaconsAll(notNaNIndices, :);
measurements = measurementsAll(:, notNaNIndices);

sys.phi = @(x) x;
sys.Phi = @(x) [1 0; 0 1];
sys.h = @(x) sqrt((x(1) - beacons(:, 1)).^2 + (x(2) - beacons(:, 2)).^2);
sys.H = @(x) [(x(1) - beacons(:, 1)) ./ sqrt((x(1) - beacons(:, 1)).^2 + (x(2) - beacons(:, 2)).^2) ...
    (x(2) - beacons(:, 2)) ./ sqrt((x(1) - beacons(:, 1)).^2 + (x(2) - beacons(:, 2)).^2)];
sys.Q = [10 0; 0 10];
sys.R = 500 * eye(size(beacons, 1));
init.x = [1100; 1500];
init.P = [500 0; 0 500];

[est] = ekf(sys, init, measurements');
% [est] = ukf(sys, init, measurements');

positionEst = [est.x]';

f = size(measurements, 1);
k = 1 : f;
positionTrueRep = repmat(positionTrue, f, 1);

e_xhat = sqrt(sum((positionTrueRep - positionEst).^2, 2));

figure
subplot(2, 2, 1) 
plot(k, positionTrueRep(:, 1), 'g-o', k, positionEst(:, 1), 'b-*')
xlabel('as'), ylabel('Poloha (x)')
subplot(2, 2, 2) 
plot(k, positionTrueRep(:, 2), 'g-o', k, positionEst(:, 2), 'b-*')
xlabel('as'), ylabel('Poloha (y)')
legend({'Skuten hodnota', 'Hodnota odhadnut pomoc KF'}, 'Location', 'southeast')
subplot(2, 2, [3, 4]) 
plot(k, e_xhat, 'b-*', k, 0, 'k')
xlabel('as'), ylabel('Chyba')
legend({'Chyba odhadu'}, 'Location', 'northeast')

