% Algoritmus 2
%
% Jedn se o lohu statick lokalizace, piem jako men jsou chpny
% odhady polohy zskan jinou lokalizan technikou
%
% Pedpokldaj se datov soubory s umstnm 'data\exp2\exp2_X.csv', 
% kde X = 1, 2, ..., 20 je slo testovacho bodu

clear

filename = 'data\exp2\exp2_1.csv';

positionTrue = csvread(filename, 0, 0, [0 0 0 1]);
measurements = csvread(filename, 1, 0);

sys.Phi = [1 0; 0 1];
sys.H = [1 0; 0 1];
sys.Q = [10 0; 0 10];
sys.R = [16000 0; 0 16000];
init.x = [measurements(1, 1); measurements(1, 2)];
init.P = [100 0; 0 100];

[est] = kf(sys, init, measurements(2 : end, :)');

positionEst = [est.x]';
positionEst = [measurements(1, :); positionEst];

f = size(measurements, 1);
k = 1 : f;
positionTrueRep = repmat(positionTrue, f, 1);

e_z = sqrt(sum((positionTrueRep - measurements).^2, 2));
e_xhat = sqrt(sum((positionTrueRep - positionEst).^2, 2));

figure
subplot(2, 2, 1) 
plot(k, positionTrueRep(:, 1), 'g-o', k, measurements(:, 1), 'r-+', k, positionEst(:, 1), 'b-*')
xlabel('as'), ylabel('Poloha (x)')
subplot(2, 2, 2) 
plot(k, positionTrueRep(:, 2), 'g-o', k, measurements(:, 2), 'r-+', k, positionEst(:, 2), 'b-*')
xlabel('as'), ylabel('Poloha (y)')
legend({'Skuten hodnota', 'Hodnota men', 'Hodnota odhadnut pomoc KF'}, 'Location', 'southeast')
subplot(2, 2, [3, 4]) 
plot(k, e_z, 'r-+', k, e_xhat, 'b-*', k, 0, 'k')
xlabel('as'), ylabel('Chyba')
legend({'Chyba men', 'Chyba odhadu'}, 'Location', 'northeast')

