% Algoritmus 4
%
% Jedn se o lohu dynamick lokalizace, piem jako men jsou chpny
% odhady poloh v jednotlivch asovch okamicch zskan jinou lokalizan
% technikou
%
% Pedpokld se datov soubor s umstnm 'data\exp4\exp4.csv', 
% obsahujc testovac data prochzkov trasy 1

clear

filename = 'data\exp4\exp4.csv';

measurements = csvread(filename, 0, 2);
f = size(measurements, 1);
positionsTrue = csvread(filename, 0, 0, [0 0 f-1 1]);

sys.Phi = [1 0 1 0; 0 1 0 1; 0 0 1 0; 0 0 0 1];
sys.H = [1 0 0 0; 0 1 0 0];
sys.Q = [50 0 0 0; 0 50 0 0; 0 0 50 0; 0 0 0 50];
sys.R = [16000 0; 0 16000];
init.x = [measurements(1, 1); 
          measurements(1, 2); 
          sign(measurements(1, 1) - measurements(2, 1)) * -50;
          sign(measurements(1, 2) - measurements(2, 2)) * -50];
init.P = [200 0 0 0; 0 200 0 0; 0 0 10 0; 0 0 0 10];

% [est] = kf(sys, init, measurements(2 : end, :)');
[est] = kf_outliers(sys, init, measurements(2 : end, :)', 500);

stateEst = [est.x];
positionsEst = stateEst(1 : 2, :)';
positionsEst = [measurements(1, :); positionsEst];

e_z = sqrt(sum((positionsTrue - measurements).^2, 2));
mse_z = mean(e_z.^2)
me_z = mean(e_z)
e_xhat = sqrt(sum((positionsTrue - positionsEst).^2, 2));
mse_xhat = mean(e_xhat.^2)
me_xhat = mean(e_xhat)

k = 1 : f;

figure
subplot(2, 2, 1) 
plot(k, positionsTrue(:, 1), 'g-o', k, measurements(:, 1), 'r-+', k, positionsEst(:, 1), 'b-*')
xlabel('as'), ylabel('Poloha (x)')
subplot(2, 2, 2) 
plot(k, positionsTrue(:, 2), 'g-o', k, measurements(:, 2), 'r-+', k, positionsEst(:, 2), 'b-*')
xlabel('as'), ylabel('Poloha (y)')
legend({'Skuten hodnota', 'Hodnota men', 'Hodnota odhadnut pomoc KF'}, 'Location', 'southeast')
subplot(2, 2, [3, 4]) 
plot(k, e_z, 'r-+', k, e_xhat, 'b-*', k, 0, 'k')
xlabel('as'), ylabel('Chyba')
legend({'Chyba men', 'Chyba odhadu'}, 'Location', 'northeast')

