function [y] = pdfnorm(x, mu, Sigma)
% Funkce hustoty pravdpodobnosti n-rozmrnho normlnho rozdlen
%
%   [y] = pdfnorm(x, mu, Sigma)
%
%   Vstupy: 
%   x ....... vektor hodnot nhodn veliiny X, n x 1
%   mu ...... vektor stednch hodnot, n x 1
%   Sigma ... kovariann matice, n x n
%   
%   Vstup: 
%   y ....... hodnota funkce hustoty pravdpodobnosti v bod x
%
%
%   Datum posledn pravy: 28. 1. 2018, KF


    y = exp(-0.5 * (x - mu)' * inv(Sigma) * (x - mu)) / sqrt(det(2 * pi * Sigma));
    
end

